package edu.ucr.util;

import java.util.Collections;

public class ProgressBar {
    // Modified from https://stackoverflow.com/a/39257908.
    public static void show(int round, int current, int total) {
        var string = new StringBuilder(140);
        var percent = (int) (current * 100.0 / total);
        string.append(String.format("\rRound %2d:", round))
                .append(String.join("", Collections.nCopies(percent == 0 ? 2 : 2 - (int) (Math.log10(percent)), " ")))
                .append(String.format(" %d%% [", percent))
                .append(String.join("", Collections.nCopies(percent, "=")))
                .append('>')
                .append(String.join("", Collections.nCopies(100 - percent, " ")))
                .append(']')
                .append(String.join("", Collections.nCopies(current == 0 ? (int) (Math.log10(total)) : (int) (Math.log10(total)) - (int) (Math.log10(current)), " ")))
                .append(String.format(" %d/%d", current, total));
        System.out.print(string);
    }
}